#include <assert.h>
#include "curl.h"

int main(void)
{
  /**
   * Note, this exploit is for 32 bit OS's. Since the maximum representable
   * time is:
   *
   * 03:14:07 UTC on Tuesday, 19 January 2038
   *
   * This input will cause undefined output, instead of outputting -1, as the
   * library desires. This is because the time itself is INT32_MAX, which is
   * valid, but then it adds 2*60*60 = 7200 seconds to this value to account
   * for the time difference change.
   *
   * This value overflows, but the check gets optimized out due to undefined
   * behavior, therefore causing the internal library to return PARSEDATE_OK.
   * Thus, the overall output will be undefined, instead of -1 to indicate an
   * error.
   *
   * A similar exploit can be done on 64 bit machines, but it would need to be
   * tailored to represent that specific date represented by INT64_MAX, which
   * is a huge date more than 292 billion years in the future.
   *
   * Furthermore, any libraries relying on curl_getdate to return a valid
   * value, or -1, could potentially be affected by this bug as well.
   */
  char   *exploit = "19 Jan 2038  03:14:07 -0200";
  time_t time = curl_getdate(exploit, NULL);

  printf("curl_getdate(\"%s\", NULL)\n", exploit);
  printf("Expected output: -1\n");
  printf("Actual output: %ld\n", time);
  /* This assertion will fail, and the value in time will be undefined. */
  assert(time == -1);

  return 0;
}
